<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 02/04/19
 * Time: 11.59
 */

namespace FiloBlu\RuleDayFromBirthday\Observer;

use Magento\Framework\UrlInterface;
use Magento\Backend\Block\Widget;


class AddGenerateBirthdayCouponObserver implements \Magento\Framework\Event\ObserverInterface
{
    protected $urlBuilder;

    protected $widget;

    public function __construct(UrlInterface $urlBuilder, Widget $widget)
    {
        $this->urlBuilder = $urlBuilder;
        $this->widget = $widget;
    }

    /**
     * Execute observer.
     * @param \Magento\Framework\Event\Observer $observer
     * @return $this
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        $form = $observer->getForm();
        $fieldset = $form->addFieldset('information_fieldset_birthday', []);

        $generateUrl = $this->urlBuilder->getUrl('sales_rule/*/birthdaycoupon');
        $fieldset->addField(
            'generate_birthday_coupon_button',
            'note',
            [
                'text' => $this->widget->getButtonHtml(
                    __('Generate Birthday Coupon'),
                    "generateCouponCodes('coupons_' ,'{$generateUrl}', 'couponCodesGridJsObject')",
                    'generate'
                )
            ]
        );

        return $this;

    }


}